Package ec.gp.push

# Class PushProblem

java.lang.Object
ec.Problem
ec.gp.GPProblem
ec.gp.push.PushProblem

All Implemented Interfaces:
  `Prototype`, `Setup`, `SimpleProblemForm`, `Serializable`, `Cloneable`

public abstract class PushProblem extends GPProblem
A PushProblem contains useful methods to help you create an interpreter, write out the ECJ GP tree to a string, build a Push Program around this string, load the interpreter with all your custom instructions, and run the Push Program on the interpreter.

Commonly you'd also set up the interpreter's data stacks with some initial data, then after running the program you might inspect the stacks to determine the return value. PushProblem also contains some helpful methods to make it easy for you to set up and modify these stacks.

See Also:
  - Serialized Form

- ## Field Summary

  ### Fields inherited from class ec.gp.GPProblem

  `input, P_DATA, P_GPPROBLEM, P_STACK, stack`

  ### Fields inherited from class ec.Problem

  `P_PROBLEM`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PushProblem()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  Creates a new individual cloned from a prototype, and suitable to begin use in its own evolutionary context.
  `void`
  `executeProgram(org.spiderland.Psh.Program program, org.spiderland.Psh.Interpreter interpreter, int maxSteps)`
  Executes the given program for up to maxSteps steps.
  `org.spiderland.Psh.Interpreter`
  `getInterpreter(EvolutionState state, GPIndividual ind, int threadnum)`
  Builds a Push Interpreter suitable for interpreting the Program given in getProgram().
  `org.spiderland.Psh.Program`
  `getProgram(EvolutionState state, GPIndividual ind)`
  Produces a Push Program from the provided GP Individual's tree.
  `boolean`
  `isFloatStackEmpty(org.spiderland.Psh.Interpreter interpreter)`
  Tests to see if the interpreter's float stack is empty.
  `boolean`
  `isIntStackEmpty(org.spiderland.Psh.Interpreter interpreter)`
  Tests to see if the interpreter's int stack is empty.
  `void`
  `pushOntoFloatStack(org.spiderland.Psh.Interpreter interpreter, float val)`
  Pushes a value onto the top of the float stack of the interpreter.
  `void`
  `pushOntoIntStack(org.spiderland.Psh.Interpreter interpreter, int val)`
  Pushes a value onto the top of the int stack of the interpreter.
  `void`
  `resetInterpreter(org.spiderland.Psh.Interpreter interpreter)`
  Clears the Interpreter's stacks so it is ready to execute another program.
  `float`
  `topOfFloatStack(org.spiderland.Psh.Interpreter interpreter)`
  Returns the top of the interpreter's float stack.
  `int`
  `topOfIntStack(org.spiderland.Psh.Interpreter interpreter)`
  Returns the top of the interpreter's int stack.

  ### Methods inherited from class ec.gp.GPProblem

  `defaultBase, setup`

  ### Methods inherited from class ec.Problem

  `canEvaluate, closeContacts, describe, describe, finishEvaluating, initializeContacts, isGroupedProblem, prepareToEvaluate, receiveAdditionalData, reinitializeContacts, sendAdditionalData, transferAdditionalData`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface ec.simple.SimpleProblemForm

  `describe, evaluate`

- ## Constructor Details

  - ### PushProblem

    public PushProblem()

- ## Method Details

  - ### clone

    public Object clone()
    Description copied from interface: `Prototype`
    Creates a new individual cloned from a prototype, and suitable to begin use in its own evolutionary context.

    Typically this should be a full "deep" clone. However, you may share certain elements with other objects rather than clone hem, depending on the situation:

    - If you hold objects which are shared with other instances, don't clone them.
    - If you hold objects which must be unique, clone them.
    - If you hold objects which were given to you as a gesture of kindness, and aren't owned by you, you probably shouldn't clone them.
    - DON'T attempt to clone: Singletons, Cliques, or Populations, or Subpopulation.
    - Arrays are not cloned automatically; you may need to clone an array if you're not sharing it with other instances. Arrays have the nice feature of being copyable by calling clone() on them.

    Implementations.

    - If no ancestor of yours implements clone(), and you have no need to do clone deeply, and you are abstract, then you should not declare clone().
    - If no ancestor of yours implements clone(), and you have no need to do clone deeply, and you are not abstract, then you should implement it as follows:

      ``

           public Object clone()
               {
               try
                   {
                   return super.clone();
                   }
               catch ((CloneNotSupportedException e)
                   { throw new InternalError(); } // never happens
               }

    - If no ancestor of yours implements clone(), but you need to deep-clone some things, then you should implement it as follows:

      ``

           public Object clone()
               {
               try
                   {
                   MyObject myobj = (MyObject) (super.clone());

                   // put your deep-cloning code here...
                   }
               catch ((CloneNotSupportedException e)
                   { throw new InternalError(); } // never happens
               return myobj;
               }

    - If an ancestor has implemented clone(), and you also need to deep clone some things, then you should implement it as follows:

      ``

           public Object clone()
               {
               MyObject myobj = (MyObject) (super.clone());

               // put your deep-cloning code here...

               return myobj;
               }

    Specified by:
      `clone` in interface `Prototype`
    Overrides:
      `clone` in class `GPProblem`

  - ### getProgram

    public org.spiderland.Psh.Program getProgram(EvolutionState state, GPIndividual ind)
    Produces a Push Program from the provided GP Individual's tree.

  - ### getInterpreter

    public org.spiderland.Psh.Interpreter getInterpreter(EvolutionState state, GPIndividual ind, int threadnum)
    Builds a Push Interpreter suitable for interpreting the Program given in getProgram().

  - ### executeProgram

    public void executeProgram(org.spiderland.Psh.Program program, org.spiderland.Psh.Interpreter interpreter, int maxSteps)
    Executes the given program for up to maxSteps steps.

  - ### resetInterpreter

    public void resetInterpreter(org.spiderland.Psh.Interpreter interpreter)
    Clears the Interpreter's stacks so it is ready to execute another program.

  - ### pushOntoFloatStack

    public void pushOntoFloatStack(org.spiderland.Psh.Interpreter interpreter, float val)
    Pushes a value onto the top of the float stack of the interpreter.

  - ### pushOntoIntStack

    public void pushOntoIntStack(org.spiderland.Psh.Interpreter interpreter, int val)
    Pushes a value onto the top of the int stack of the interpreter.

  - ### isFloatStackEmpty

    public boolean isFloatStackEmpty(org.spiderland.Psh.Interpreter interpreter)
    Tests to see if the interpreter's float stack is empty.

  - ### isIntStackEmpty

    public boolean isIntStackEmpty(org.spiderland.Psh.Interpreter interpreter)
    Tests to see if the interpreter's int stack is empty.

  - ### topOfFloatStack

    public float topOfFloatStack(org.spiderland.Psh.Interpreter interpreter)
    Returns the top of the interpreter's float stack.

  - ### topOfIntStack

    public int topOfIntStack(org.spiderland.Psh.Interpreter interpreter)
    Returns the top of the interpreter's int stack.